<template>
  <div
    v-lazy-container="lazyload ? { selector: 'img' } : { selector: 'none' }"
    :style="ratioStyle"
    class="img-container"
    :class="{ transparent: src.endsWith('.png'), lazyload }"
  >
    <img v-bind="attributes" />
  </div>
</template>

<script>
export default {
  props: {
      image: {
        type: Object,
        default: () => {},
      },
      ratio: { type: String, default: '16x9' },
      ratioLg: { type: String, default: '' },
      lazyload: { type: Boolean, default: true },
      sizes: { type: String, default: '' },
  },
  computed: {
    ratioComputed() {
      if (process.client) {
          if (
              (this.$mq === 'lg' ||
                  this.$mq === 'xl' ||
                  this.$mq === 'xxl') &&
              this.ratioLg !== ''
          ) {
              return this.ratioLg;
          }
      }
      return this.ratio;
    },
    ratioStyle() {
      let ratioArray = [];

      if (this.ratioComputed !== 'variable') {
        ratioArray = this.ratioComputed.split('x');
      }

      if (this.ratioComputed === 'variable' && this.image && this.image.mediaDetails.sizes) {
        const sizes = this.image.mediaDetails.sizes.filter(size => size.name.includes(this.ratioComputed));
        ratioArray = [
          sizes[sizes.length -1].width,
          sizes[sizes.length -1].height,
        ];
      }

      const ratioPercent =
          (parseInt(ratioArray[1], 10) / parseInt(ratioArray[0], 10)) *
          100;

      return `position: relative; padding-bottom: ${ratioPercent}%;`;
    },
    imgStyle() {
      return this.ratioStyle !== ''
          ? 'position: absolute; left: 0; top: 50%; transform: translateY(-50%);'
          : '';
    },
    src() {
      if (this.image && this.image.mediaDetails.sizes) {
      const sizes = this.image.mediaDetails.sizes.filter(size => size.name === `${this.ratioComputed}_64`);

      return `${sizes[0].sourceUrl}`;
      }
      return '';
    },
    srcset() {
      let sizes = []
      const srcset = [];

      if (this.image && this.image.mediaDetails.sizes) {
        sizes = this.image.mediaDetails.sizes.filter(size => size.name.includes(this.ratioComputed));
      }

      sizes.forEach((size) => {
        // exclude thumbnail (this.src)
        if (size.sourceUrl !== this.src) {
          srcset.push(
              `${size.sourceUrl} ${size.name.split('_')[1]}w`,
          );
        }
      });

      return srcset.join(', ');
    },
    attributes() {
      const defaultAttr = {
        'alt': this.image ? this.image.alt : '',
        'style': this.image ? this.imgStyle : '',
        'src': this.src,
      };

      if (this.lazyload) {
        return { ...defaultAttr,
          ...{
            'data-srcset': this.srcset,
            'data-src': this.src,
            'loading': this.src
          }
        };
      }

      return { ...defaultAttr,
        ...{
          'srcset': this.srcset,
        }
      };
    },
  },
};
</script>

<style lang="scss" scoped>
.img-container {
  overflow: hidden;
  background: $gray;

  &.transparent {
    background: transparent;
    overflow: visible;
  }

  &.lazyload {
    img {
      filter: blur(5px);

      @include media-breakpoint-up(xl) {
        transition: filter 0.5s;
      }

      &[lazy='loaded'] {
        filter: blur(0);
      }
    }
  }
}

img {
  width: 100%;
  max-width: 100%;
  max-height: 100%;
  display: block;
  position: relative;
}
</style>
